#! /usr/bin/env python

# -----------------------------------------------------------------------------------
# write_event.py
# 
# The Script shows an confirmation window, as well as the location that the current/new 
# located event has been written.
# 
# (C) Henrik Thoms - GFZ-Potsdam
#
# Created: 16/03/2006 Revision: 
# ------------------------------------------------------------------------------------

import os
import glob
import shutil
import sys

from Tkinter import *


class ConfirmWdw(Frame):
    
    def __init__(self, master = None):

        Frame.__init__(self, master, takefocus = 1)
        
        self.master.title('Confirmation')
        
        retVal = os.popen2('xwininfo -root | grep "Width" | cut -d: -f2', 'r')
        xOffset = retVal[1].read().strip()
        retVal =  os.popen2('xwininfo -root | grep "Height" | cut -d: -f2', 'r')
        yOffset = retVal[1].read().strip()
        
        # width = 200
        # height = 70
        # xOffset = (int(xOffset) / 2) - (width / 2)
        #yOffset = (int(yOffset) / 2) - (height / 2)
        
        #self.master.wm_geometry('%dx%d+%d+%d' % (width, height, xOffset, yOffset) )
        #self.master.protocol('WM_DELETE_WINDOW', self._windowClose)
        
        #Register global event handler
        self.bind_all('<Any-KeyPress>', self._evtHandler)
        self.grid( sticky = N+S+W+E )
        
        # This is necessary to make the window resizeable
        top = self.winfo_toplevel()                
        top.rowconfigure(0, weight = 1)
        top.columnconfigure( 0, weight = 1 )        
        
        self.rowconfigure( 0, weight = 1 )
        self.columnconfigure( 0, weight = 1 )       

        # Define a label
        self._labelText = StringVar()
        evt = '#evtPath#'
        self._labelText.set('Current event has been written to:\n%s' % (evt))
        self._label = Label(self, textvariable = self._labelText,
                            anchor = W, justify = LEFT)
        
        # Calculate size and position
        width = len(evt) * 8
        height = 70
        xOffset = (int(xOffset) / 2) - (width / 2)
        yOffset = (int(yOffset) / 2) - (height / 2)
        self.master.wm_geometry('%dx%d+%d+%d' % (width, height, xOffset, yOffset) )
        
        self._label.grid(row = 0, column = 0)
        
        # Define an ok button
        self._okButton = Button(self, text='ok')
        self._okButton.grid(row = 1, column = 0, columnspan = 1, sticky=E+W)
        self._okButton.bind('<1>', self._myExit)
        self._okButton.bind_all('<KeyRelease-Return>', self._myExit)

   
    # Default event handler which is registered to the root panel
    def _evtHandler(self, evt = None):
        
        if evt.keysym == 'Return' or evt.num == 1 or evt.keysym == 'Escape':
              self._okButton.config(relief = SUNKEN)
              self._okButton.update()
              self.quit()
        else:
           print 'Event: ' + evt.keysym + ' is not registered'

    
    def _myExit(self, evt = None):

        if evt.keysym == 'Return':
            self._okButton.config(relief = RAISED)
            self._okButton.update()
            self.quit()
        elif evt.num == 1:
            self._evtHandler(evt)
            self.quit()



if __name__ == '__main__':
    
    wdw = ConfirmWdw(Tk())
    wdw.mainloop()
