
/* file FCTXHL.H
 *      ========
 *
 * version 1, 22-MAY-91
 *
 * prototypes of module SHHELP.C
 * K. Stammler, 22-MAY-91
 */


#ifndef __FCTXHL
#define __FCTXHL

/* prototypes of module SHHELP.C */

/*------------------------------------------------------------------------*/


void hl_full( int ch, char *dir, char *cmds, int *status );

/* displays full help file matching the wild card string "cmds" */

/* parameters of routine */
/* int      ch;             input; output channel(s) */
/* char     *dir;           input; directory string to look for */
/* char     *cmds;          input; command wild card string */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void hl_hdr( int ch, char *dir, char *cmds, int *status );

/* displays header line of help file matching the wild card string "cmds" */

/* parameters of routine */
/* int      ch;             input; output channel(s) */
/* char     *dir;           input; directory string to look for */
/* char     *cmds;          input; command wild card string */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void hl_dir( int ch, char *dir, char *cmds, int linewidth, int *status );

/* displays directory of help file matching the wild card string "cmds" */

/* parameters of routine */
/* int      ch;             input; output channel(s) */
/* char     *dir;           input; directory string to look for */
/* char     *cmds;          input; command wild card string */
/* int      linewidth;      input; linewidth in characters */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void hl_key( int ch, char *dir, char *cmds, int linewidth, int *status );

/* displays key line of help file matching the wild card string "cmds" */

/* parameters of routine */
/* int      ch;             input; output channel(s) */
/* char     *dir;           input; directory string to look for */
/* char     *cmds;          input; command wild card string */
/* int      linewidth;      input; width of line in chars */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/

#endif /* __FCTXHL */
