
/* file ITUSRDEF.H
 *      ==========
 *
 * version 1, 29-OCT-91
 *
 * error codes and prototypes of module INCITHEO
 * K. Stammler, 29-OCT-91
 */


#ifndef __ITUSRDEF
#define __ITUSRDEF

#define ITE_OFFSET 3400

#define ITE_STROVFL     (ITE_OFFSET+1)    /* string overflow */
#define ITE_DISTRANGE   (ITE_OFFSET+2)    /* distance out of range */
#define ITE_DEPTHRANGE  (ITE_OFFSET+3)    /* depth out of range */
#define ITE_OPNRD       (ITE_OFFSET+4)    /* error opening input file */
#define ITE_FILREAD     (ITE_OFFSET+5)    /* error reading file */
#define ITE_FCNV        (ITE_OFFSET+6)    /* error converting float string */ 


/*------------------------------------------------------------------------*/


void it_settable( char table[], STATUS *status );

/* sets new table name
 *
 * parameters of routine
 * char       table[];      input; new table name
 * STATUS     *status;      output; return status
 */


/*------------------------------------------------------------------------*/


float it_getinci( float distance, float depth, STATUS *status );

/* returns angle of incidence in degrees
 *
 * parameters of routine
 * float      distance;     input; distance of event in degrees
 * float      depth;        input; depth of event in km
 * STATUS     *status;      output; return status
 *                          returns angle of incidence of P in degrees
 */


/*------------------------------------------------------------------------*/

#endif /* __ITUSRDEF */
