/* file lgusrdef.h
 *      ==========
 *
 * version 1, 5-Sep-92
 *
 * prototypes of module logplot.c
 * K. Stammler, 5-Sep-92
 */



/* error codes */
#define LGE_OFFSET       5200
#define LGE_ILLSCALE     (LGE_OFFSET+1)   /* illegal scaling */


/* constants */
#define LGC_NOCHANGE 1000.0
	/* no change in lg_labshift parameter */



/*---------------------------------------------------------------------*/


void lg_setwindow( CHMAP wdw );

/* sets output window for logplot
 *
 * parameter of routine
 * CHMAP     wdw;      input; output window
 */


/*---------------------------------------------------------------------*/


void lg_labshift( REAL ha_hs, REAL ha_vs, REAL va_hs, REAL va_vs );

/* sets label positions
 *
 * parameters of routine
 * REAL       ha_hs;   input; horizontal pos. at horizontal axis
 * REAL       ha_vs;   input; vertical pos. at horizontal axis
 * REAL       va_hs;   input; horizontal pos. at vertical axis
 * REAL       va_vs;   input; vertical pos. at vertical axis
 */


/*---------------------------------------------------------------------*/


void lg_scale( int style, REAL lofrq, REAL hifrq, REAL loamp,
	REAL hiamp, STATUS *status );

/* set scale of plots
 *
 * parameters of routine
 * int        style;             input; drawing style
 * REAL       lofrq, hifrq;      input; frequency bounds
 * REAL       loamp, hiamp;      input; amplitude bounds
 * STATUS     *status;           output; return status
 */


/*---------------------------------------------------------------------*/


void lg_logplot( int style, SAMPLE smp[], long lth, REAL offset,
	REAL delta );

/* plot trace into logplot window
 *
 * parameters of routine
 * int        style;        input; style number
 * SAMPLE     smp[];        input; trace to plot
 * long       lth;          input; length of trace
 * REAL       offset;       input; frq offset of trace
 * REAL       delta;        input; x-increment
 */


/*---------------------------------------------------------------------*/
