
/* file QIUSRDEF.H
 *      ==========
 *
 * version 1, 22-MAY-91
 *
 * prototypes of routines of module QFINTRFC.C
 * K. Stammler, 22-MAY-91
 */


#ifndef __QIUSRDEF
#define __QIUSRDEF

#define QIC_EMPTY 0
#define QIC_RSRVD -1

/*---------------------------------------------------------------------------*/


void qi_initcnv( void );

/* initialises the conversion array */


/*---------------------------------------------------------------------------*/


void qi_define( unsigned sh_entry, unsigned qf_entry, int *status );

/* defines new entry
 *
 * parameters of routine
 * unsigned   sh_entry;     input; SH entry number (with type)
 * unsigned   qf_entry;     input; q-file entry (without type)
 * int        *status;      output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvlidx( unsigned ent, int *status );

/* returns long q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnviidx( unsigned ent, int *status );

/* returns int q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvbidx( unsigned ent, int *status );

/* returns byte q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvridx( unsigned ent, int *status );

/* returns real q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvsidx( unsigned ent, int *status );

/* returns string q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvcidx( unsigned ent, int *status );

/* returns char q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvtidx( unsigned ent, int *status );

/* returns time q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/


int qi_cnvfidx( unsigned ent, int *status );

/* returns flag q-index
 *
 * parameters of routine
 * unsigned     ent;       input; sh entry number
 * int          *status;   output; return status
 */


/*---------------------------------------------------------------------------*/

#endif /* __QIUSRDEF */
