
/* file TRUSRDEF.H
 *      ==========
 *
 * version 1, 22-MAY-91
 *
 * prototypes of module SHTRANSL.C
 * K. Stammler, 22-MAY-91
 */


#ifndef __TRUSRDEF
#define __TRUSRDEF

#ifndef __CPUSRDEF
#include "cpusrdef.h"
#endif

/*------------------------------------------------------------------------*/


void tr_partrans( PARAM *par, int *status );

/* translates all parameters in "par" */

/* parameters of routine */
/* PARAM    *par;           modify; parameters to be translated */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void tr_translate( char *str, int maxlth, int *status );

/* translates string */

/* parameters of routine */
/* char     *str;           modify; string to be translated */
/* int      maxlth;         maximum string length */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void tr_parse( char *str, char *chid, char *name, char *idxstr, int *status );

/* extracts from string char ID, variable name & index string */

/* parameters of routine */
/* char     *str;           input; string to be parsed */
/* char     *chid;          output; char ID */
/* char     *name;          output; name of variable */
/* char     *idxstr;        output; index string */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void tr_rdline( char *name, char *idxstr, int maxlth, char *str, int *status );

/* reads line number "idxstr" from file "name" */

/* parameters of routine */
/* char     *name;          input; name of file */
/* char     *idxstr;        input; line number */
/* int      maxlth;         input; maximum string length (of str) */
/* char     *str;           output; line read */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void tr_infent( char *name, char *trcno, int maxlth, char *str, int *status );

/* reads info "name" from trace "trcno" */

/* parameters of routine */
/* char     *name;          input; name of file */
/* char     *trcno;         input; trace position number */
/* int      maxlth;         input; maximum string length (of str) */
/* char     *str;           output; line read */
/* int      *status;        output; return status */


/*------------------------------------------------------------------------*/


void tr_setruntrc( void *trc, int idx );

/* sets running trace pointer
 *
 * parameter of routine
 * void      *trc;      input; new trace pointer for X
 * int       idx;       input; position number
 */


/*------------------------------------------------------------------------*/


void tr_intern( char *name, char *idxstr, int maxlth, char *str, int *status );

/* returns internal variable 
 *
 * parameters of routine
 * char       *name;     input; name of variable
 * char       *idxstr;   input; index string
 * int        maxlth;    input; maximum length of output string
 * char       *str;      output; translated string
 * int        *status;   output; return status
 */


/*------------------------------------------------------------------------*/

#endif /* __TRUSRDEF */
