
/* file ev2hypo.c
 *      =========
 *
 * version 3, 4-Nov-93
 *
 * reformats event to HYPOELLIPSE format
 * K. Stammler, 8-Sep-93
 */



#include <stdio.h>
#include <string.h>
#include BASECNST
#ifdef BC_INC_STDLIB
#include BC_INC_STDLIB
#endif
#include BC_SYSBASE
#include BC_CPAR
#include "eventdsc.h"
#include "evhypo.h"



int main( int argc, char *argv[] )
{
	/* local variables */
	char      infile[BC_FILELTH+1];    /* input file */
	char      outfile[BC_FILELTH+1];   /* output file */
	EvStatusT status;                  /* return status */
	BOOLEAN   fix_depth;               /* use fixed depth */
	char      *val;                    /* pointer to value */
	float     depth;                   /* value of fixed depth */

	/* executable code */

	pa_init( argc, argv );

	if  (pa_pnumber() < 1 || *pa_pvalue(1) == EvEOS)  {
		printf( "   input filename: " );
		EvReadLineInteractive( stdin, BC_FILELTH, infile );
	} else {
		strcpy( infile, pa_pvalue(1) );
	} /*endif*/

	if  (pa_pnumber() < 2 || *pa_pvalue(2) == EvEOS)  {
		printf( "   output filename: " );
		EvReadLineInteractive( stdin, BC_FILELTH, outfile );
	} else {
		strcpy( outfile, pa_pvalue(2) );
	} /*endif*/

	fix_depth = pa_qspecified( "-d" );
	if  (fix_depth)  {
		val = pa_qvalue( "-d" );
		if  (val == NULL || strcmp(val,"free") == 0)  {
			fix_depth = FALSE;
			depth = 0.0;
		} else if  (sscanf( pa_qvalue("-d"), "%f", &depth ) != 1)  {
			printf( "*** ev2hypo: couldn't read depth ***\n" );
			exit( 1 );
		} /*endif*/
	} /*endif*/

	EfSetHypoUseS( pa_qspecified( "-s" ) );
	EfSetHypoDepth( fix_depth, depth );

	status = EveNOERROR;
	EvReformatEventfile( infile, outfile, EvGetEvent,
		EfPutHypo, &status );

#	ifndef BC_VAX
	return 0;
#	endif

} /* end of main */
