
/* file ev4hypou.c
 *      ==========
 *
 * version 2, 2-Nov-93
 *
 * reformats HYPOELLIPSE output file to event-file format
 * K. Stammler, 12-Sep-93
 */



#include <stdio.h>
#include <string.h>
#include BASECNST
#include BC_SYSBASE
#include "eventdsc.h"
#include "evhypout.h"



int main( int argc, char *argv[] )
{
	/* local variables */
	char      infile[BC_FILELTH+1];    /* input file */
	char      outfile[BC_FILELTH+1];   /* output file */
	EvStatusT status;                  /* return status */

	/* executable code */

	if  (argc < 2 || argv[1][0] == EvEOS)  {
		printf( "   input filename: " );
		EvReadLineInteractive( stdin, BC_FILELTH, infile );
	} else {
		strcpy( infile, argv[1] );
	} /*endif*/

	if  (argc < 3 || argv[2][0] == EvEOS)  {
		printf( "   output filename: " );
		EvReadLineInteractive( stdin, BC_FILELTH, outfile );
	} else {
		strcpy( outfile, argv[2] );
	} /*endif*/

	status = EveNOERROR;
	EvReformatEventfile( infile, outfile, EfGetHypoOut,
		EvPutEvent, &status );

	EfAppendStationInfo( outfile );

#	ifndef BC_VAX
	return 0;
#	endif

} /* end of main */
