from seis._types import Trace, Time, Station, Event # , _Location
from seis._types import TimeFromQlib2, str2time

__all__ = [ "Trace", "Time", "Station", "Event", "time", "str2time" ]

def time(s=None):
    """
    time() -> seis.Time object

    If no argument is specified, return the current time provided by the
    system clock. Fractions of a second may *not* be present on all systems.
    """
    if isinstance(s, str):
        return str2time(s)
    if s: return Time(time1970=s)
    
    import time as pytime
    return Time(time1970=pytime.time())


#class Trace(cTrace): # _Trace is the underlying C implementation

#    def __init__(self, f=None, *args, **kwargs):
#        from copy  import deepcopy as cp
#        from types import FileType, StringType
#        cTrace.__init__(self, *args, **kwargs)
#        if not f: return 
#        if isTrace(f):
#            self.cha, self.sta, self.evt = cp(f.cha), cp(f.sta), cp(f.evt)
#            self.data, self.time = cp(f.data), cp(f.time)
#            self.log, self.com = cp(f.log), cp(f.com)
#            self.extra[:] = f.extra[:]
#            self.fsamp, self.gain = f.fsamp, f.gain
#            return
#        if isinstance(f, StringType):
#            f = file(f)
#        if isinstance(f, FileType):
#            if not self.read(f):
#                raise EOFError
#        else:
#            raise ValueError, "failed to initialize seis.Trace"

#    def __str__(self):
#        return "%-5s%4s %s %s" % \
#            (self.sta.code.upper(), self.cha.upper(), \
#             str(self.time), str(self.evt.time))

#   def __sub__(self, other):
#       from copy import deepcopy
#       tmp = deepcopy(self)
#       tmp.data = tmp.data - other.data
#       return tmp

#   def __add__(self, other):
#       from copy import deepcopy
#       tmp = deepcopy(self)
#       tmp.data = tmp.data + other.data
#       return tmp

#    def __len__(self):
#        return self.nsamp/self.fsamp
#
#    def __pos__(self):
#        return self

#    def __copy__(self):
#        trc = Trace()
#        trc.evt, trc.sta, trc.data = self.evt, self.sta, self.data
#        trc.log, trc.com, trc.time = self.log, self.com, self.time
#        trc.fsamp, trc.gain = self.fsamp, self.gain
#        trc.extra[:] = self.extra[:]
#        for attr in self.__dict__.keys():
#            setattr(t, attr, self.__dict__[attr])
#        return trc

#    def __deepcopy__(self, memo=None):
#        from copy import deepcopy as cp
#        t = Trace()
#        t.cha, t.sta, t.evt = cp(self.cha), cp(self.sta), cp(self.evt)
#        t.data, t.time = cp(self.data), cp(self.time)
#        t.log, t.com = cp(self.log), cp(self.com)
#        t.extra[:] = self.extra[:]
#        t.fsamp, t.gain = self.fsamp, self.gain
#        for attr in self.__dict__.keys():
#            setattr(t, attr, cp(self.__dict__[attr]))
#        return t

#    def toComplex(self):
#        tp = self.type
#        if tp in ['f', 'd']:
#                self.data = self.data.astype(tp.upper())
#        else:   raise TypeError, "cannot convert data type '%c' to complex" % tp
#
#    def toReal(self):
#        tp = self.type
#        if tp in ['F', 'D']:
#                self.data = self.data.astype(tp.lower())
#        else:   raise TypeError, "cannot convert data type '%c' to real" % tp

#   def setGain(self, gain=1.E09):
#       if self.gain==gain: return
#       sflag = self.data.spacesaver()
#       self.data.savespace(1)
#       self.data, self.gain = self.data*(gain/float(self.gain)), gain
#       self.data.savespace(sflag)

#    def minmax(self, offset=None, length=None, time=None):
#        from seis._cext import _minmax
#        if offset and length:
#            if time:  noff = int((time-self.time+offset)*self.fsamp+0.5)
#            else:     noff = int(offset*self.fsamp+0.5)
#            nlen = int(length*self.fsamp+0.5)
#            f = self.data
#            _min, _max = _minmax(f, noff, noff+nlen)
#            return _min, _max
#        else: f = self.data
#        return min(f), max(f)

#    def cut(self, offset=0, length=10, time=None):
#        if time:  noff = int((time-self.time+offset)*self.fsamp+0.5)
#        else:     noff = int(offset*self.fsamp+0.5)
#        nlen = int(length*self.fsamp+0.5)
#        if noff<0:
#            nlen += noff
#            noff  = 0
##       if noff+nlen > self.nsamp:
##           nlen = self.nsamp-noff
#        self.data  = self.data[noff:noff+nlen]
#        self.time += noff/self.fsamp
#
# end of class Trace

#class Location(_Location): pass
