/***************************************************************************
 *   Copyright (C) 2009 by seismo   *
 *   seismo@localhost   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <string.h>
#include <GL/glut.h>                           // LINUX
#include <libslink.h>
#ifndef WIN32
  #include <signal.h>

  static void term_handler (int sig);
#else
  #define strcasecmp _stricmp
#endif
#define PACKAGE "rttime"
#define VERSION LIBSLINK_VERSION

#define nch 600
  SLpacket * slpack;
  int seqnum;
  int ptype;
static short int ppackets = 0;
static short int verbose  = 0;
int     WINH      = 400;               // DEFAULT WINDOW HEIGHT IN PIXELS
int     WINL      = 1500;              // DEFAULT WINDOW LENGTH IN PIXELS
int     xo        = 0;                 // coordinates for position on screen
int     yo        = 0;                 // coordinates for position on screen
int     sindob    = 0;                 // single or double buffering
int     siz       = 500;               // height of window in pixels
int     sizx      = 1200;
int     no_to_plot;
int     ystart;
int     xstart;
int     yst;
int     xst;
char    box1[50];
int     start_stop = 0;
int     no_stations = 0;
char    toplot[nch][80];
char    last_time[nch][80];
char    station_name[nch][80];
char    time_string[nch][80];
char    sta[nch][80];
char    rtid[nch][80];
double  latency[nch];
double  latency_all[nch];
double  MSECS_OLD[nch];
char    syscmd[80];
char    syscmd1[80];
char    ipaddress[80];
char    *topdir       = 0;               // top directory SEISAN
char    *topdir_rt     = 0;               // top directory RTQUAKE
int     nr[500];
  int x1t[500],y1t[500],x2t[500],y2t[500];
float   R=0.0;
float   G=0.0;
float   B=0.0;
int     RunMode = 1;		       // Used as a boolean (1 or 0) for "on" and "off"
static  SLCD * slconn;	               // connection parameters 
static void packet_handler (char *msrecord, int packet_type,
			    int seqnum, int packet_size);
static int parameter_proc (int argcount, char **argvec);
static char *getoptval (int argcount, char **argvec, int argopt);
static void usage (void); 
static void Cnv_CPUtime();
static void LATENCY();
static void LATENCY_ALL();
static void sort_components();
static int checkline();
static void pipe_slinktool();
static void strip();
static void draw_square();


void mouse(int btn, int state, int x, int y) 
{
  FILE *out;
  char stream[80];
  char stat[80];
  char tempo1[80];
  char tempo2[80];
  char syscmd[180];
  char filnam1[80];
  char filnam2[80];
  char filnam3[80];
  char filnam4[80];
  char filnam5[80];
  int  rt1;
  int yy;
  int p,l,t;
  yy = glutGet(GLUT_WINDOW_HEIGHT);
  y = yy - y;                        /* In Glut, Y coordinate increases from top to bottom */

  glColor3f(1.0, 1.0, 1.0);
  glBegin(GL_POINTS); 
  glVertex2i(x, y);
  glEnd();
  glFlush();


  if (state == GLUT_DOWN) 
  {
    if(btn == GLUT_LEFT_BUTTON)
    {
//    printf("DOWN: x=%3d  y=%3d \n", x, y);
      for(p=0;p<no_to_plot;p++)
      {
        if(x>x1t[p] && x<x2t[p] && y>y1t[p] && y<y2t[p])
          break;
      }
      if(p < no_to_plot)
      {
        sprintf(filnam1,"%s/par/streams.rtgraph",topdir_rt);
	printf("Create file: %s\n",filnam1);
        if ((out = fopen (filnam1, "w")) == NULL)
        {
          printf("Can't open: %s\n",filnam1);
	  exit(0);
        }
        for(l=0;l<80;l++)
        {
          stat[l]='\0';
          stream[l]='\0';
          tempo1[l]='\0';
          tempo2[l]='\0';
        }
        strncpy(tempo1,sta[p],9);

        for(l=0;l<2;l++)
          tempo2[l]=sta[p][l+12];
        strcat(tempo1,tempo2);
        strcat(tempo1,"?.D");
//      printf("%s\n",tempo1);
        fprintf(out,"%s\n",tempo1);
        fclose(out);
        sprintf(filnam2,"%s/par/stations.rtgraph",topdir_rt);
        printf("Create file: %s\n",filnam2);
        if ((out = fopen (filnam2, "w")) == NULL)
        {
          printf("Can't open: %s\n",filnam2);
	  exit(0);
        }
//      printf("STA:%s\n",sta[p]);

        for(t=0;t<3;t++)
        {
          for(l=0;l<80;l++)
          {
            stat[l]='\0';
            stream[l]='\0';
            tempo1[l]='\0';
            tempo2[l]='\0';
          }
          for(l=0;l<5;l++)          // station name
            tempo2[l]=sta[p][l+3];
          for(l=0;l<2;l++)          // location
            tempo1[l]=sta[p][l+9];
          for(l=0;l<2;l++)
            stream[l]=sta[p][l+12];
          strcat(stat,tempo2);
          strcat(stat,tempo1);
          strcat(stat,stream);
          if(sta[p][0] == 'I' && sta[p][1] == 'U')
          {
            switch(t)
            {
              case 0:
              strcat(stat,"Z");
              break;
              case 1:
              strcat(stat,"1");
              break;
              case 2:
              strcat(stat,"2");
              break;
            }
          }else{
            switch(t)
            {
              case 0:
              strcat(stat,"Z");
              break;
              case 1:
              strcat(stat,"N");
              break;
              case 2:
              strcat(stat,"E");
              break;
            }
          }
//          if(stat[5]== ' ')stat[5]='0';
//          if(stat[6]== ' ')stat[6]='0';
          fprintf(out,"%s\n",stat);
        }
        fclose(out);
      
        sprintf(syscmd,"%s/bin/rtnet -buf %d -m 1 -l streams.rtgraph -f stations.rtgraph %s &",topdir_rt,sindob,ipaddress);
//        printf("%s\n",syscmd);
        rt1=system(syscmd);
      }
    }else{
//      printf("RIGHT BUTTON\n");
      for(p=0;p<no_to_plot;p++)
      {
        if(x>x1t[p] && x<x2t[p] && y>y1t[p] && y<y2t[p])
          break;
      }
//      printf("NO_TO_PLOT: %d THIS: %d %s\n",no_to_plot,p,sta[p]);
      for(l=0;l<80;l++)
        filnam3[l]='\0';

      sprintf(filnam3,"%s",sta[p]);
//      printf("FILNAM3: %s\n",filnam3);

      for(p=0;p<15;p++)
        if(filnam3[p]==' ') filnam3[p]='_';
      filnam3[14]='*';
      sprintf(syscmd,"%s/bin/rttplt -comp %s &",topdir_rt,filnam3);
      printf("%s\n",syscmd);
      rt1=system(syscmd);
    }
  }
  else {

//    printf("UP: x=%3d  y=%3d \n", x, y);
  }
}

void motion(int x, int y) {
   int yy;

   yy = glutGet(GLUT_WINDOW_HEIGHT);
   y = yy - y;

   glColor3f(1.0, 1.0, 1.0);
   glBegin(GL_POINTS); 
      glVertex2i(x, y);
   glEnd();
   glFlush();

//   printf("motion: x=%3d  y=%3d \n", x, y);
}
void
my_reshape(int w, int h)
{
   GLdouble size;
   GLdouble aspect;

   /* Use the whole window. */
   glViewport(0, 0, w, h);

   /* We are going to do some 2-D orthographic drawing. */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   size = (GLdouble)((w >= h) ? w : h) / 2.0;
   if (w <= h) {
      aspect = (GLdouble)h/(GLdouble)w;
      glOrtho(-size, size, -size*aspect, size*aspect, -100000.0, 100000.0);
   }
   else {
      aspect = (GLdouble)w/(GLdouble)h;
      glOrtho(-size*aspect, size*aspect, -size, size, -100000.0, 100000.0);
   }

   /* Make the world and window coordinates coincide so that 1.0 in */
   /* model space equals one pixel in window space.                 */
   glScaled(aspect, aspect, 1.0);

   /* Now determine where to draw things. */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

}
void bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}
void drawScene(void)
{
  int r;
  int ch;

  pipe_slinktool();
  sort_components();
  for(r=0;r<no_stations;r++)
    LATENCY(r);
  for(r=0;r<no_to_plot;r++)
    LATENCY_ALL(r);







// Flush the pipeline, swap the buffers
  glFlush();
  glutSwapBuffers();
  if ( RunMode==1 ) 
  {
    glutPostRedisplay();	// Trigger an automatic redraw for animation
  }
  strip(ch);                               // PLOT THIS CHANNEL IN CORRESPONDING VIEWPORT
  sleep(1);
}
void 
my_handle_key(unsigned char key, int x, int y)
{
  int l;
//printf("%d\n",key);
   switch (key) {

   case 27:        // ESC exit
   exit(1);
   break;

   case 83:        // S Hold
   start_stop=1;
   break;
   case 115:       // s Resume
   start_stop=0;
   break;



   case 104:       // help
   printf("**************************************************************\n");
   printf("* List of key-press functions:                               *\n");
   printf("* ----------------------------                               *\n");
   printf("* h  : list this on screen                                   *\n");
   printf("* esc: exit                                                  *\n");
   printf("* u  : increase amplitude on all channels                    *\n");
   printf("* d  : decrease amplitude on all channels                    *\n");
   printf("* S  : freeze graphics                                       *\n");
   printf("* s  : resume graphics                                       *\n");
   printf("* n  : next channel                                          *\n");
   printf("* +  : increase amplitude on current channel                 *\n");
   printf("* -  : decrease amplitude on current channel                 *\n");
   printf("* F  : turn on pre-set filter                                *\n");
   printf("* f  : turn off filtering                                    *\n");
   printf("* 1  : Set color scheme to default                           *\n");
   printf("* 2  : Color scheme 2                                        *\n");
   printf("* 3  : Color scheme 3                                        *\n");
   printf("* 4  : Color scheme 4                                        *\n");
   printf("**************************************************************\n"); 
   break;

   default:
      break;
   }
//  printf("%4.1f %4.1f %4.1f\n",R,G,B);
}
void draw_square(int x1,int y1,int x2,int y2)
{
  glBegin(GL_LINES);        // draw box # 1
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y1-(WINH/2));

  glVertex2f(x2-(WINL/2), y1-(WINH/2));
  glVertex2f(x2-(WINL/2), y2-(WINH/2));

  glVertex2f(x2-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y2-(WINH/2));

  glVertex2f(x1-(WINL/2), y2-(WINH/2));
  glVertex2f(x1-(WINL/2), y1-(WINH/2));
  glEnd();
}
void strip(int line)
{

  int   p;
  int   g;
  int   l;
  int   hgt;
  int   wdt;
  int   xin;

  int retur;
  int x1,y1,x2,y2;

  int   late1,late2;
  double k;
  char  tekst1[100];
  char  tekst2[100];
  char  header[400];
  char  id_lst[3];
  char  id_nxt[3];
  char  id_lab[3];
  int mm[nch][5];
  k=3380000000.0;

  glColor3f(0.0, 0.0, 0.0);                 // draw frame in black
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);
/*
  glColor3f(1.0,0.0,0.0);
  glBegin( GL_LINES );                      // Plot line under title
  glVertex2f( -WINL/2, 290 );
  glVertex2f( WINL/2, 290 );
  glEnd();
*/
  ystart = WINH/2-0;
  ystart = ystart - 50;
  xstart = -WINL/2+10;

  x1=xstart;
  y1=ystart;
  x2=xstart+150;
  y2=ystart+30;

  for(p=0;p<6;p++)                          // plot top squares with limits
  {
    switch(p)
    {
      case 0:
      glColor3f(0.0,1.0,1.0);               // agua negative latency
      sprintf(tekst1,"negative latency");
      break;
      case 1:
      glColor3f(0.0,1.0,0.0);               // green 0 <=latency<60
      sprintf(tekst1,"< 1 minute");
      break;
      case 2:
      glColor3f(1.0,1.0,0.0);               // yellow 60<=latency<600
      sprintf(tekst1,"< 10 minutes");
      break;
      case 3:
      glColor3f(1.0, 0.549, 0.0);           // orange 600<=latency<3600
      sprintf(tekst1,"< 1 hour");
      break;
      case 4:
      glColor3f(1.0, 0.0, 0.0);             // red 3600<=latency<86400
      sprintf(tekst1,"< 1 day");
      break;
      case 5:
      glColor3f(0.662, 0.662, 0.662);       // dark-gray 86400
      sprintf(tekst1,"> 1 day");
      break;
    }
    glRecti(x1,y1,x2,y2);
    glColor3f(0.0, 0.0, 0.0);

    bitmap_output(x1+5, y1+7, tekst1,GLUT_BITMAP_9_BY_15 );
    x1=x1+155;
    x2=x2+155;
  }


  hgt=30;
  wdt=80;
  xin=40;


  ystart = ystart - 50;
  xstart = -WINL/2+xin;

  x1=xstart;
  y1=ystart;
  x2=xstart+wdt;
  y2=ystart+hgt;
  for(p=0;p<3;p++)
  {
    id_lst[p]='\0';
    id_nxt[p]='\0';
//     id_lab[p]='\0';
  }
  strncpy(id_lst,station_name[0],2);
  strncpy(id_lab,station_name[0],2);
//  printf("id_lst: %s\n",id_lst);
      glColor3f(1.0, 0.0, 0.0);
      bitmap_output(-(WINL/2-10), y1, id_lab,GLUT_BITMAP_9_BY_15 );
  for(p=0;p<no_stations;p++)                // Plot squares each station
  {
    strncpy(id_nxt,station_name[p],2);
//    printf("id_nxt: %s\n",id_nxt);
    retur=strncmp(id_lst,id_nxt,2);
    if(retur != 0)
    {
      strncpy(id_lst,id_nxt,2);
      xstart = -WINL/2+xin;
      x1=xstart;
      y1=y1-hgt-10;
      x2=xstart+wdt;
      y2=y2-hgt-10;
      glColor3f(1.0, 0.0, 0.0);
      bitmap_output(-(WINL/2-10), y1, id_nxt,GLUT_BITMAP_9_BY_15 );
//      bitmap_output(-740, -200, id_nxt,GLUT_BITMAP_9_BY_15 );
    }
    glColor3f(1.0, 1.0, 1.0);
    bitmap_output(x1+2, y1+2, id_nxt,GLUT_BITMAP_9_BY_15 );

    late1=(int)latency[p];
    if(late1 < 0)
      glColor3f(0.0,1.0,1.0);               // agua negative latency
    if(late1 >=0 && late1 <= 60)
      glColor3f(0.0,1.0,0.0);               // green 0 <=latency<60
    if(late1 >= 60 && late1 < 600)  
      glColor3f(1.0,1.0,0.0);               // yellow 60<=latency<600
    if(late1 >= 600 && late1 < 3600)
      glColor3f(1.0, 0.549, 0.0);           // orange 600<=latency<3600
    if(late1 >= 3600 && late1 < 86400)
      glColor3f(1.0, 0.0, 0.0);             // red 3600<=latency<86400
    if(late1 > 86400)
      glColor3f(0.662, 0.662, 0.662);       // dark-gray 86400

    x1t[p]=x1-(-WINL/2);
    y1t[p]=y1-(-WINH/2);
    x2t[p]=x2-(-WINL/2);
    y2t[p]=y2-(-WINH/2);
//    printf("[x1,y1]=%4d,%4d [x2,y2]=%4d,%4d %4d %4d %4d %4d\n",x1,y1,x2,y2,x1t[p],y1t[p],x2t[p],y2t[p]);
    glRecti(x1,y1,x2,y2);
    glColor3f(0.0, 0.0, 0.0);
    sprintf(tekst1,"%s",station_name[p]);
    bitmap_output(x1+2, y1+18, tekst1,GLUT_BITMAP_9_BY_15 );

    sprintf(tekst1,"%5d",late1);
    bitmap_output(x1+2, y1+2, tekst1,GLUT_BITMAP_9_BY_15 );

    x1=x1+wdt+5;
    x2=x2+wdt+5;
    if(x2>(WINL/2))
    {
      xstart = -WINL/2+xin;
      x1=xstart;
      y1=y1-hgt-10;
      x2=xstart+wdt;
      y2=y2-hgt-10;
    }
  }
  ystart = WINH/2-50;
  xstart = -WINL/2+xin;
}


void pipe_slinktool ()
{
  FILE *fp;
  int status;
  char path[20000];
  char linje[200000];
  char station[80];
  char navn[80];
  char tempo[80];

  char key[80];
  char key2[80];
  char cur[80];
  char cur2[80];
  int ind=0;
  int teller=0;
  int ret;
  int count=0;
  int i,l,no,k;
  int br=0;

  char pip[80];
  sprintf(pip,"%s/bin/slinktool -Q %s | sort --k=1,2",topdir_rt,ipaddress);
  fp = popen(pip, "r");


  no = 500;
  i=0;
  l=0;
  for(i=0;i<no;i++)
  {
    if((fgets(linje, 200000, fp)) != NULL)
    {
//      printf("%3d %s",i,linje);
      ind=0;
      count=0;
      for(k=0;k<80;k++)
      {
        key[k]='\0';
        key2[k]='\0';
        cur[k]='\0';
        cur2[k]='\0';
      }
      ind=checkline(linje);
      if(ind == 3)
      { 
//printf("pipe_slinktool ind: %d\n",ind);
//      printf("%3d %s",i,linje);    
        sprintf(tempo,"%s",linje);
        for(l=0;l<80;l++)
        {
          station[l]='\0';
          navn[l]='\0';
          toplot[i][l]='\0';
          last_time[i][l]='\0';
        }
        strncpy(station,linje,15);
//        printf("Station: %s\n",station);
//  getchar();
        sprintf(toplot[teller], "%s",station);
//printf("%s\n",toplot[teller]);
        for(l=0;l<24;l++)
          navn[l]=linje[l+47];
        sprintf(last_time[teller],"%s",navn);
        teller++;
      }
    }else{
      break;
    }
  }
  status = pclose(fp);     
//      printf("End of file. File contains: %2d items\n",teller);
      no_to_plot = teller;
 }

int checkline(char *line)
{
  int ind=0;
//  printf("%s\n",line);
//  if(line[0] != 'I' && line[1] != 'U')             // if NOT IU-station
//  {

    if(line[9] == '0' && line[10] == '0') ind++;   // location '00'
    if(line[9] == '1' && line[10] == '0') ind++;   // location '10'
    if(line[9] == ' ' && line[10] == ' ') ind++;   // location '  '

    if(line[14] == 'Z' || line[14] == 'N' || line[14] == 'E' || line[14] == '1' || line[14] == '2') ind++;
    if(line[12] == 'B' || line[12] == 'H' || line[12] == 'S' || line[12] == 'E' || line[12] == 'N') ind++;
//  }else{                                          // this is IU station
//    printf("%s",line);
//    if(line[9] == '1' && line[10] == '0')
//    {
//      ind++;   // location 10
//      printf("%d %s",ind,line);
//    }
//    if(ind == 1)                                    // right location
//    {
//      if(line[12] == 'B' && line[13] == 'H' && line[14] == 'Z') ind++;

//      ind++;
//    }
//  }
//  printf("checkline ind: %d\n",ind);
//  getchar();
  return(ind);
}

void sort_components()
{
  int i,j,k,l,m;
  char key[80];
  char key2[80];
  char cur[80];
  char cur2[80];
  int  retur;
  int  teller;

  j = 0;
//  printf("NO_TO_PLOT: %d\n",no_to_plot);
  for(i=0;i<no_to_plot;i++)
  {
    for(m=0;m<80;m++)
    {
      key[m]='\0';
      key2[m]='\0';
      cur[m]='\0';
      cur2[m]='\0';
    }
    teller = 0;
    strncpy(key,toplot[i],11);
    sprintf(key2,"%s",key);
//    printf("A: %4d %s\n",i,key2);
    for(k=0;k<no_to_plot;k++)
    {
      strncpy(cur,toplot[k],11);
      sprintf(cur2,"%s",cur);
//printf("key2: %s  cur2: %s\n",key2,cur2);
//getchar();
      retur=strncmp(key2,cur2,11);
      if(retur==0) // equal ?
        teller++;
    }  // k----------
//    printf("%d\n",teller);
    i=i+teller - 1;

    sprintf(station_name[j],"%s",key2);
    sprintf(sta[j],"%s",toplot[i]);
    sprintf(time_string[j],"%s",last_time[i]);
    nr[j]= teller;
    j++;
  } // i-----
  no_stations = j;
//  printf("NO_STATIONS: %d\n",no_stations);
}

int main(int argc, char **argv)
{

  int p;
  int re;
  int printarg=1;

//------------------------------------------------------------------------
// set path to RTQUAKE_TOP as default
//------------------------------------------------------------------------
  topdir_rt = (char*)getenv("RTQUAKE_TOP");
  if (topdir_rt)
  {
    printf("RTTIME: RTQUAKE_TOP: %s\n", topdir_rt);
  }else{
    printf("RTTIME: RTQUAKE_TOP not defined\n");
    printf("Include setup_rt.bash or setup_rt.csh in your .bashrc or .csh\n");
    exit(0);      
  }
//------------------------------------------------------------------------- 
// Allocate and initialize a new connection description SEEDLINK
//-------------------------------------------------------------------------
  slconn = sl_newslcd();
//-------------------------------------------------------------------------
// Process command line parameters
//-------------------------------------------------------------------------
  if (parameter_proc (argc, argv) < 0)
  {
    fprintf(stderr, "Parameter processing failed\n\n");
    fprintf(stderr, "Try '-h' for detailed help\n");
    return -1;
  }
  WINH = siz;
  WINL = sizx;
  pipe_slinktool();
  sort_components();
  for(p=0;p<no_stations;p++)
    LATENCY(p);
  for(p=0;p<no_to_plot;p++)
    LATENCY_ALL(p);
//  for(p=0;p<no_to_plot;p++)
//    printf("%3d %s %10.2f\n",p,toplot[p],latency_all[p]);
  xstart = -WINL/2+5;
//  WINH = (no_stations+1) * 18;
  ystart = WINH/2-50;
//  printf("ystart: %d WINL: %d WINH: %d\n",ystart,WINL,WINH);
//*******************************************************************
// Set up for OpenGL graphics
//*******************************************************************
  glutInit(&argc,argv);

// We're going to animate it, so double buffer 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );

// Window position (from top corner), and size (width% and hieght)
  glutInitWindowPosition( xo, yo );


// Set window size in pixels
  glutInitWindowSize( WINL, WINH );

// Create window with title given in parameters
  glutCreateWindow( "LATENCY MONITORING" );

    glutMouseFunc(mouse);
//    glutPassiveMotionFunc(motion);


  glColor3f(0.0, 0.0, 0.0);
  glRecti(-WINL/2,-WINH/2,WINL/2,WINH/2);

// Detects a key-press. ESC exits program
   glutKeyboardFunc(my_handle_key);


// call this whenever window needs redrawing
  glutDisplayFunc( drawScene );

  glutReshapeFunc(my_reshape);


// Start the main loop.  glutMainLoop never returns.
  glutMainLoop(  );

  return 0;

}
//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
void DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
void TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}
void LATENCY_ALL(int kanal)
{
  FILE *out;
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  double MSECS;
  int    sz;
  int    lengde;
  int seconds_cpu;
  char tiden_cpu[80];
  char millis_cpu[4];
  char tpath[100];
  char lines[100];
  long day_cpu;
  long mon_cpu;
  long yrn_cpu;
  long hrn_cpu;
  long min_cpu;

  int iday_cpu;
  int imon_cpu;
  int iyrn_cpu;
  int ihrn_cpu;
  int imin_cpu;

  float sek_cpu;
  char dm[10];
  char buf[50000];
  char *ptr;
  double MSECS_CPU;
  double DIFF;

  char dum[50];
  int i,j,n;
  char   timestamp[80];
  struct timeb  tp;               // structure CPU time


  lengde = 1000;



  ftime(&tp);               // CPU time
  seconds_cpu=tp.time;
  sprintf(tiden_cpu,"%s",ctime(&tp.time));
  sprintf(millis_cpu,"%3d",tp.millitm);
  Cnv_CPUtime(tiden_cpu,millis_cpu);

  sscanf(tiden_cpu,"%2d%1s%2d%1s%4d %2d%1s%2d%1s%f6.3",
&iday_cpu,dm,&imon_cpu,dm,&iyrn_cpu,&ihrn_cpu,dm,&imin_cpu,dm,&sek_cpu);
  yrn_cpu=iyrn_cpu;
  mon_cpu=imon_cpu;
  day_cpu=iday_cpu;
  hrn_cpu=ihrn_cpu;
  min_cpu=imin_cpu;
  TIMSEC(yrn_cpu,mon_cpu,day_cpu,hrn_cpu,min_cpu,sek_cpu,&MSECS_CPU);


  sscanf(last_time[kanal],"%4d%1c%2d%1c%2d%1c%2d%1c%2d%1c%f6.3",&iyrn,dum,&imon,dum,&iday,dum,&ihrn,dum,&imin,dum,&sek);
  yrn=iyrn;
  mon=imon;
  day=iday;
  hrn=ihrn;
  min=imin;

//  printf("%4d %3d %2d %2d %4.1f\n",YR,DY,hrn,min,sek);


  yrn=yrn-2000;

  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;

  sprintf(timestamp,"%2d/%2d/%2d %2d:%2d:%6.3f",iday,imon,iyrn,ihrn,imin,sek);
  if(timestamp[0] == ' ') timestamp[0] = '0';
  if(timestamp[3] == ' ') timestamp[3] = '0';
  if(timestamp[6] == ' ') timestamp[6] = '0';
  if(timestamp[9] == ' ') timestamp[9] = '0';
  if(timestamp[12] == ' ') timestamp[12] = '0';
  if(timestamp[15] == ' ') timestamp[15] = '0';
  if(timestamp[18] == ' ') timestamp[18] = '0';
  if(timestamp[19] == ' ') timestamp[19] = '0';
  if(timestamp[20] == ' ') timestamp[20] = '0';
//printf("%s %s\n",toplot[kanal],timestamp);
//      printf("TIME: %4d %2d %2d %2d %2d %4.1f\n",yrn,mon,day,hrn,min,sek);
  TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
  latency_all[kanal] = MSECS_CPU - MSECS + 1.0;

  DIFF = MSECS_CPU - MSECS_OLD[kanal];
  if(DIFF >= 60.0)
  {
    sprintf(tpath,"%s/rt/latency/%s",topdir_rt,toplot[kanal]);
    for(j=0;j<80;j++)
      if(tpath[j]==' ')tpath[j]='_';
//    printf("%s\n",tpath);
    if ((out = fopen (tpath,"a")) == NULL) // open file latency data 
    {
      printf("Can't open: %s\n",tpath);
      printf("Check if path really exists\n");
      exit(0);
    }
    for(j=0;j<100;j++)
      lines[j]='\0';
    iyrn_cpu=yrn_cpu;
    imon_cpu=mon_cpu;
    iday_cpu=day_cpu;
    ihrn_cpu=hrn_cpu;
    imin_cpu=min_cpu;
    sprintf(lines,"%s %4d %2d %2d %2d %2d %4.1f %10.1f",toplot[kanal],iyrn_cpu,imon_cpu,iday_cpu,ihrn_cpu,imin_cpu,sek_cpu,latency_all[kanal]);
    fprintf(out,"%s\n",lines);
    fclose(out);
    if ((out = fopen (tpath,"r")) == NULL) // open file latency data 
    {
      printf("Can't open: %s\n",tpath);
    }
    n=fread(buf,1,(lengde+1)*49,out);
    fseek(out,0L,SEEK_END);
    sz=ftell(out);
//    printf("SIZE: %d lines: %d\n",sz,n/49);

    fclose(out);
//    printf("N: %d\n",n);
    if(n>(lengde*49))
    {
//      printf("File full\n");
      if ((out = fopen (tpath,"w")) == NULL) // open file latency data 
      {
        printf("Can't open: %s\n",tpath);
      }
      ptr = buf + 49;
      fwrite(ptr,1,(49*lengde),out);
      fclose(out);
    }
    MSECS_OLD[kanal] = MSECS_CPU;
  }
}
void LATENCY(int kanal)
{
  int DDAY,MMTH;
  int DY;
  int YR;
  long   yrn;
  long   mon;
  long   day;
  long   hrn;
  long   min;

  int   iyrn;
  int   imon;
  int   iday;
  int   ihrn;
  int   imin;

  float  sek;
  double MSECS;

  int seconds_cpu;
  char tiden_cpu[80];
  char millis_cpu[4];
  long day_cpu;
  long mon_cpu;
  long yrn_cpu;
  long hrn_cpu;
  long min_cpu;

  int iday_cpu;
  int imon_cpu;
  int iyrn_cpu;
  int ihrn_cpu;
  int imin_cpu;

  float sek_cpu;
  char dm[10];
  double MSECS_CPU;


  char dum[50];
  int i,j;
  char   timestamp[80];
  struct timeb  tp;               // structure CPU time


  ftime(&tp);               // CPU time
  seconds_cpu=tp.time;
  sprintf(tiden_cpu,"%s",ctime(&tp.time));
  sprintf(millis_cpu,"%3d",tp.millitm);
  Cnv_CPUtime(tiden_cpu,millis_cpu);

  sscanf(tiden_cpu,"%2d%1s%2d%1s%4d %2d%1s%2d%1s%f6.3",
&iday_cpu,dm,&imon_cpu,dm,&iyrn_cpu,&ihrn_cpu,dm,&imin_cpu,dm,&sek_cpu);
  day_cpu=iday_cpu;
  mon_cpu=imon_cpu;
  yrn_cpu=iyrn_cpu;
  hrn_cpu=ihrn_cpu;
  min_cpu=imin_cpu;

  TIMSEC(yrn_cpu,mon_cpu,day_cpu,hrn_cpu,min_cpu,sek_cpu,&MSECS_CPU);

  sscanf(time_string[kanal],"%4d%1c%2d%1c%2d%1c%2d%1c%2d%1c%f6.3",&iyrn,dum,&imon,dum,&iday,dum,&ihrn,dum,&imin,dum,&sek);
  yrn=iyrn;
  mon=imon;
  day=iday;
  hrn=ihrn;
  min=imin;
//  printf("%4d %3d %2d %2d %4.1f\n",YR,DY,hrn,min,sek);

//  DTE (DY,&DDAY,&MMTH,YR);     //-- convert from doy to date  
//  yrn=YR;
  yrn=yrn-2000;
//  mon=MMTH;
//  day=DDAY;

  iday=day;
  imon=mon;
  iyrn=yrn;
  ihrn=hrn;
  imin=min;
  sprintf(timestamp,"%2d/%2d/%2d %2d:%2d:%6.3f",iday,imon,iyrn,ihrn,imin,sek);
  if(timestamp[0] == ' ') timestamp[0] = '0';
  if(timestamp[3] == ' ') timestamp[3] = '0';
  if(timestamp[6] == ' ') timestamp[6] = '0';
  if(timestamp[9] == ' ') timestamp[9] = '0';
  if(timestamp[12] == ' ') timestamp[12] = '0';
  if(timestamp[15] == ' ') timestamp[15] = '0';
  if(timestamp[18] == ' ') timestamp[18] = '0';
  if(timestamp[19] == ' ') timestamp[19] = '0';
  if(timestamp[20] == ' ') timestamp[20] = '0';
//printf("%s %s\n",toplot[kanal],timestamp);
//      printf("TIME: %4d %2d %2d %2d %2d %4.1f\n",yrn,mon,day,hrn,min,sek);
  TIMSEC(yrn,mon,day,hrn,min,sek,&MSECS);
  latency[kanal] = MSECS_CPU - MSECS + 1.0;
//  spt->latency[klon][kanal] = latency[kanal];
}
void Cnv_CPUtime(char tiden[],char millis[])
{
  int ret;
  char word[4];
      word[0]=tiden[4];
      word[1]=tiden[5];
      word[2]=tiden[6];
      word[3]='\0';


      tiden[0]=tiden[8];
      tiden[1]=tiden[9];
      tiden[2]='/';
      ret=strcmp(word,"Jan");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='1';
      }
      ret=strcmp(word,"Feb");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='2';
      }
      ret=strcmp(word,"Mar");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='3';
      }
      ret=strcmp(word,"Apr");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='4';
      }
      ret=strcmp(word,"May");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='5';
      }
      ret=strcmp(word,"Jun");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='6';
      }
      ret=strcmp(word,"Jul");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='7';
      }
      ret=strcmp(word,"Aug");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='8';
      }
      ret=strcmp(word,"Sep");
      if(ret==0)
      {
        tiden[3]='0';
        tiden[4]='9';
      }
      ret=strcmp(word,"Oct");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='0';
      }
      ret=strcmp(word,"Nov");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='1';
      }
      ret=strcmp(word,"Dec");
      if(ret==0)
      {
        tiden[3]='1';
        tiden[4]='2';
      }
      tiden[5]='/';
      tiden[6]=tiden[20];
      tiden[7]=tiden[21];
      tiden[8]=tiden[22];
      tiden[9]=tiden[23];
      tiden[19]='.';


      tiden[20]=millis[0];
      tiden[21]=millis[1];
      tiden[22]=millis[2];
      tiden[23]='\n';



}

/***************************************************************************
 * parameter_proc:
 *
 * Process the command line parameters.
 *
 * Returns 0 on success, and -1 on failure
 ***************************************************************************/
static int
parameter_proc (int argcount, char **argvec)
{
  int optind;
  int error = 0;
  char tm[80];
  char *streamfile  = 0;	/* stream list file for configuring streams */
  char *multiselect = 0;
  char *selectors   = 0;
  if (argcount <= 1)
    error++;

  /* Process all command line arguments */
  for (optind = 1; optind < argcount; optind++)
    {
      if (strcmp (argvec[optind], "-h") == 0)
	{
	  usage();
	  exit (0);
	}
      else if (strcmp (argvec[optind], "-top") == 0)
	{
	  topdir_rt = argvec[++optind];
//          printf("top directory: %s\n",topdir);
	}
      else if (strcmp (argvec[optind], "-sizy") == 0)
      {
        siz = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-sizx") == 0)
      {
        sizx = atoi(argvec[++optind]);
      }      
      else if (strcmp (argvec[optind], "-xo") == 0)
      {
        xo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-yo") == 0)
      {
        yo = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-buf") == 0)
      {
        sindob = atoi(argvec[++optind]);
      }
      else if (strcmp (argvec[optind], "-p") == 0)
	{
	  ppackets = 1;
	}
      else if (strcmp (argvec[optind], "-l") == 0)
	{
	  streamfile = argvec[++optind];
	}
      else if (strncmp (argvec[optind], "-", 1 ) == 0)
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
      else if (!slconn->sladdr)
	{
	  slconn->sladdr = argvec[optind];
//printf("server: %s\n",argvec[optind]);
  sprintf(ipaddress,"%s",argvec[optind]);
	}
      else
	{
	  fprintf(stderr, "Unknown option: %s\n", argvec[optind]);
	  exit (1);
	}
    }

  /* Make sure a server was specified */
  if ( ! slconn->sladdr )
    {
      fprintf(stderr, "No SeedLink server specified\n\n");
      fprintf(stderr, "Usage: %s [options] [host][:port]\n", PACKAGE);
      fprintf(stderr, "Try '-h' for detailed help\n");
      exit (1);
    }

  /* Load the stream list from a file if specified */
  if ( streamfile )
    sl_read_streamlist (slconn, streamfile, selectors);


  /* If errors then report the usage message and quit */
  if (error)
    {
      usage ();
      exit (1);
    }
  return 0;
}				/* End of parameter_proc() */

/***************************************************************************
 * getoptval:
 * Return the value to a command line option; checking that the value is 
 * itself not an option (starting with '-') and is not past the end of
 * the argument list.
 *
 * argcount: total arguments in argvec
 * argvec: argument list
 * argopt: index of option to process, value is expected to be at argopt+1
 *
 * Returns value on success and exits with error message on failure
 ***************************************************************************/
static char *
getoptval (int argcount, char **argvec, int argopt)
{
  if ( argvec == NULL || argvec[argopt] == NULL ) {
    fprintf (stderr, "getoptval(): NULL option requested\n");
    exit (1);
  }
  
  /* Special case of '-o -' usage */
  if ( (argopt+1) < argcount && strcmp (argvec[argopt], "-o") == 0 )
    if ( strcmp (argvec[argopt+1], "-") == 0 )
      return argvec[argopt+1];
  
  if ( (argopt+1) < argcount && *argvec[argopt+1] != '-' )
    return argvec[argopt+1];

  fprintf (stderr, "Option %s requires a value\n", argvec[argopt]);
  exit (1);
}  /* End of getoptval() */
/***************************************************************************
 * usage:
 * Print the usage message and exit.
 ***************************************************************************/
static void
usage (void)
{

  fprintf (stderr, "\nCommand: %s [options] [host][:port]\n\n", PACKAGE);
  fprintf (stderr,
	   "Options:\n"
	   " -h             show this usage message\n"
           " -top           top directory (default: /home/seismo)\n"
           " -sizx pixels   length of window in pixels (default: 1200)\n"   
           " -sizy pixels   height of window in pixels (default: 500)\n"
           " -buf n         0-double 1-single buffering (default: 0)\n"
           " -xo  pixels    position of window x-direction (default: 0)\n"
           " -yo  pixels    position of window y-direction (default: 0)\n"

	   " [host][:port]  Address of the SeedLink server in host:port format\n"
	   "                f.ex.: 129.177.55.xx:18000\n"
	   "                f.ex.: localhost:18000\n\n");
  
}				/* End of usage() */
/***************************************************************************
 * packet_handler():
 * Process a received packet based on packet type.
 ***************************************************************************/
static void
packet_handler (char *msrecord, int packet_type, int seqnum, int packet_size)
{
  static SLMSrecord * msr = NULL;

  double dtime;			/* Epoch time */
  double secfrac;		/* Fractional part of epoch time */
  time_t itime;			/* Integer part of epoch time */
  char timestamp[20];
  struct tm *timep;

  /* The following is dependent on the packet type values in libslink.h */
  char *type[]  = { "Data", "Detection", "Calibration", "Timing",
		    "Message", "General", "Request", "Info",
                    "Info (terminated)", "KeepAlive" };

  /* Build a current local time string */
  dtime   = sl_dtime ();
  secfrac = (double) ((double)dtime - (int)dtime);
  itime   = (time_t) dtime;
  timep   = localtime (&itime);
  snprintf (timestamp, 20, "%04d.%03d.%02d:%02d:%02d.%01.0f",
	    timep->tm_year + 1900, timep->tm_yday + 1, timep->tm_hour,
	    timep->tm_min, timep->tm_sec, secfrac);

  /* Process waveform data */
  if ( packet_type == SLDATA )
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette:\n",
	      timestamp, seqnum, type[packet_type]);

      sl_msr_parse (slconn->log, msrecord, &msr, 1, 0);

      if ( verbose || ppackets )
	sl_msr_print (slconn->log, msr, ppackets);
    }
  else if ( packet_type == SLKEEP )
    {
      sl_log (0, 2, "Keep alive packet received\n");
    }
  else
    {
      sl_log (0, 1, "%s, seq %d, Received %s blockette\n",
	      timestamp, seqnum, type[packet_type]);
    }
}				/* End of packet_handler() */








